
// fonctions utilitaires (hors classes)

/////////////////////////////////////////////////////////////////////////////

void erreur(int n) { tco(CODE_ERREUR,0,n); } // TCO

/////////////////////////////////////////////////////////////////////////////
// les fonctions pour le cab-signal

void signalChange(Signal* s) { Zone* zone; Train* train; // le signal vu par le train change CAB
  zone=s->zone; if (zone==NULL) { erreur(1); return; } // precaution
  train=zone->train; if (train==NULL) { /*erreur(2);*/ return; } // pas de train
  if (train->sens==SENS_PAIR) { if (s!=zone->signalPair) return; }   // pas bon sens ou pas signal
  else                        { if (s!=zone->signalImpair) return; } // pas bon sens ou pas signal
  tco(CODE_CAB,s->getFeux(),train->no);
}

void signalVu(Train* t) { Signal* signal; // le signal vu par le train   CAB
  if (t==NULL) return; 
  if (t->sens==SENS_PAIR) signal=t->zone->signalPair;
  else                    signal=t->zone->signalImpair;
  if (signal!=NULL) tco(CODE_CAB,signal->getFeux(),t->no); // test si signal   
  else              tco(CODE_CAB,E,t->no); // pas de signal (eteint)
}

/////////////////////////////////////////////////////////////////////////////
// aubiner un ou plusieurs signaux
inline void aubiner(Signal* s) { s->aubiner(); }
inline void aubiner(Signal* s1,Signal* s2) { s1->aubiner(); s2->aubiner(); }
       void aubiner(Signal* s1,Signal* s2,Signal* s3) { s1->aubiner(); s2->aubiner(); s3->aubiner(); }

// tester si une ou plusieurs zone(s) sont libre(s)
inline boolean libre(Zone* a) { return a->libre(); }
inline boolean libres(Zone* a,Zone* b) { return a->libre() && b->libre(); }
       boolean libres(Zone* a,Zone* b,Zone* c) { return a->libre() && b->libre()&& c->libre(); }
       boolean libres(Zone* a,Zone* b,Zone* c,Zone* d) { return a->libre() && b->libre() && c->libre() && d->libre(); }

// tester si une ou plusieurs zone(s) sont occupee(s)
  boolean occupee(Zone* z) { return z->occupee(); } //   OPTION
  boolean occupees(Zone* z1,Zone* z2) { return z1->occupee() || z2->occupee(); } //   OPTION
  boolean occupees(Zone* z1,Zone* z2,Zone* z3) { return z1->occupee() || z2->occupee() || z3->occupee(); } //   OPTION

// tester si un ou plusieurs itineraire(s) sont libre(s)
inline boolean libre(Itineraire* a) { return a->libre(); }
inline boolean libres(Itineraire* a,Itineraire* b) { return a->libre() && b->libre(); }
       boolean libres(Itineraire* a,Itineraire* b,Itineraire* c) { return a->libre() && b->libre()&& c->libre(); }
       boolean libres(Itineraire* a,Itineraire* b,Itineraire* c,Itineraire* d) { return a->libre() && b->libre() && c->libre() && d->libre(); }
       boolean libres(Itineraire* a,Itineraire* b,Itineraire* c,Itineraire* d,Itineraire* e) { return a->libre() && b->libre() && c->libre() && d->libre() && e->libre(); }
       boolean libres(Itineraire* a,Itineraire* b,Itineraire* c,Itineraire* d,Itineraire* e,Itineraire* f) { return a->libre() && b->libre() && c->libre() && d->libre() && e->libre() && f->libre(); }

// detruire un ou plusieurs itineraire
inline void detruire(Itineraire* i) { i->detruire(); }
inline void detruire(Itineraire* i1,Itineraire* i2) { i1->detruire(); i2->detruire(); }
       void detruire(Itineraire* i1,Itineraire* i2,Itineraire* i3) { i1->detruire(); i2->detruire(); i3->detruire(); }
       void detruire(Itineraire* i1,Itineraire* i2,Itineraire* i3,Itineraire* i4) { i1->detruire(); i2->detruire(); i3->detruire(); i4->detruire(); }
       void detruire(Itineraire* i1,Itineraire* i2,Itineraire* i3,Itineraire* i4,Itineraire* i5) { i1->detruire(); i2->detruire(); i3->detruire(); i4->detruire(); i5->detruire(); }

// tracer un itineraire sur plusieurs zones   TCO
       void trace(boolean b,Zone* z1,Zone* z2,Zone* z3) { z1->tracer(b); z2->tracer(b); z3->tracer(b); }

/////////////////////////////////////////////////////////////////////////////

