
// le méthodes des composants 

/////////////////////////////////////////////////////////////////////////////
// les methodes d'aiguille

inline boolean Aiguille::manoeuvrable() { return zone->libre(); } // OPTION zone

boolean Aiguille::directer() { if (directe()) return true; if (!manoeuvrer()) return false; etat=AIGUILLE_DIRECTE; return true; }

boolean Aiguille::devier()   { if (deviee())  return true; if (!manoeuvrer())  return false; etat=AIGUILLE_DEVIEE;  return true; }

boolean Aiguille::manoeuvrer() { // appele quand une aiguille est manoeuvree
  // COMPLETER mettre ici le code qui manoeuvre effectivement l'aiguille ( utiliser le booleen etat et l'entier no )
  tco(CODE_AIGUILLE,etat,no);
  return true; // return false si cela c'est mal passe
}

//void  Aiguille::erreur() {}

//  //  // //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //
// les methodes de zone

Zone::Zone(int n,Signal* sp,Signal* si) { // constructeur   OPTION
  no=n; signalPair=sp; signalImpair=si;  
  if (signalPair!=NULL)   signalPair->zone=this;   // lien croise
  if (signalImpair!=NULL) signalImpair->zone=this; // lien croise
}

void Zone::occuper() { Zone* z; // appelée par la rétrosignalisation
  if (etat==ZONE_OCCUPEE) return; etat=ZONE_OCCUPEE;
  actions(); // fait les actions spécifiques à une zone
  // COMPLETER fait tout ce qu'il y a à faire en cas d'occupation (actions communes à toutes les zones)
  z=provenance();
  if (z!=NULL) { // erreur???
    train=z->train;
    train->zone=this;
    if (train!=NULL) tco(CODE_TRAIN,train->no,no); // TCO
  }
  // COMPLETER fait les actions de l'utilisateur (TCO, CAB, ... )
  tco(CODE_ZONE,COULEUR_ROUGE,no); // TCO
  if (train!=NULL) signalVu(train); // CAB
 }

void Zone::liberer() { // appelée par la rétrosignalisation
  if (etat==ZONE_LIBRE) return; etat=ZONE_LIBRE;
  desactions(); // fait les actions spécifiques à une zone
  // COMPLETER fait tout ce qu'il y a à faire en cas de libération (actions communes à toutes les zones)
  tco(CODE_TRAIN,0,no); // TCO
  train=NULL;
  // COMPLETER fait les actions de l'utilisateur (TCO)
  tco(CODE_ZONE,trace?COULEUR_BLANCHE:COULEUR_GRISE,no); // TCO
}
void Zone::tracer(boolean b) { 
    if (b) trace++; else trace--;
    if (occupee()) return;
    if (trace>=1) tco(CODE_ZONE,COULEUR_BLANCHE,no);
    else          tco(CODE_ZONE,COULEUR_GRISE,no);
}

Zone* Zone::provenance() { Zone* p; Zone* i; // OPTION
   // if (type==SENS_IMPAIR_SEUL) return suivantePaire();   // optimisation (si type)
   // if (type==SENS_PAIR_SEUL)   return suivanteImpaire(); // optimisation (si type)
   p=suivantePaire();   if (p!=NULL && p->libre()) p=NULL; // candidate si non nulle et occupee
   i=suivanteImpaire(); if (i!=NULL && i->libre()) i=NULL; // candidate si non nulle et occupee
   if (p!=NULL) if (i==NULL) return p; else return(ambiguite()); // deux candidates (ambiguite)
   else         if (i!=NULL) return i; else erreur(202); // aucune candidate (erreur)
   return NULL;
}

inline Zone* Zone::selonAiguille(Aiguille* a,Zone* z1,Zone* z2) { return a->directe()?z1:z2; } 
 
void Zone::erreur(int n) { tco(CODE_ERREUR,0,n); } // TCO

/////////////////////////////////////////////////////////////////////////////
// les methodes de signal

void Signal::manoeuvrer() { // appele quand un signal change (feux et/ou cible)
  // COMPLETER manoeuvrer le signal (s'il existe ) ( utiliser l'entier feu et l'entier no ( eventuellement l'entier type ))
  // gerer la zone d'arret si elle existe
  if (no>=2) tco(CODE_CARRE,feux,no-1);  // TCO
  else       tco(CODE_SIGNAL,feux,no+1); // TCO
  signalChange(this); // CAB    
}

void Signal::manoeuvreEtMajFeux() { Signal* s;  
  s=precedent(); if (s==NULL) { erreur(302); return ; }
  manoeuvrer(); s->majFeux(); 
}

void Signal::erreur(int n) { 
  tco(CODE_ERREUR,0,n); // TCO
} 

/////////////////////////////////////////////////////////////////////////////
// la methode d'autorisation

boolean Autorisation::prenable(boolean s) { 
  if (sens==s) return !prise; // meme sens
  return !prise && aucunTrain(); // pas meme sens
}

/////////////////////////////////////////////////////////////////////////////
// les methodes d'itineraire

boolean Itineraire::formation() { // essai formation 
  if (formable()) { former(); etat=ITINERAIRE_FORME; tracer(true); tco(CODE_BOUTON,COULEUR_BLANCHE,no); return true; } 
  else { etat=ITINERAIRE_EN_ATTENTE; tco(CODE_BOUTON_CLI,COULEUR_BLANCHE,no); return false; }
}

boolean Itineraire::destruction() { // essai deformation 
  if (deformable()) { deformer(); etat=ITINERAIRE_LIBRE; tracer(false); 
                      tco(CODE_BOUTON,COULEUR_GRISE,no); // TCO
                      return true; } 
  return false;
}

void Itineraire::detruire() { // destruction
  if (etat==ITINERAIRE_LIBRE) return;
  if (etat==ITINERAIRE_EN_ATTENTE) return;  
  deformer(); tracer(false); 
  etat=ITINERAIRE_LIBRE; 
  tco(CODE_BOUTON,COULEUR_GRISE,no); // TCO
  } 

void Itineraire::effacer() { // effacement de la memorisation   OPTION
  etat=ITINERAIRE_LIBRE; 
  tco(CODE_BOUTON,COULEUR_GRISE,no); // TCO
}

/////////////////////////////////////////////////////////////////////////////

