

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

abstract class Pave extends Case {
  Forme[] formes;
  Forme retrait; // mettre plusieurs
  int col,lin; // les cordonnees du pave
  int couleur=COULEUR_GRISE; // couleur de la derniere forme (gris)
  boolean sens; // sens du pave (pair ou impair)
  float angle=0; // pour orientation des locos
  int rot=0; boolean sym=false; // pour orientation de la loco
  
  Pave() {} // constructeur vide
  Pave(float a,boolean s,Forme... fs) { angle=a; formes=fs; sens=s; } // constructeur
  
  public void dessiner(int x,int y,int n) { int l=formes.length;
    for (int i=0; i<l; i++) {
      if (i==l-1) formes[i].dessiner(x*9,y*9,n,couleur);   // la derniere forme
      else        formes[i].dessiner(x*9,y*9,n,COULEUR_NOIRE); // les autres formes (noir)
    }
    if (retrait!=null) retrait.dessiner(x*9,y*9,n,COULEUR_FOND); // couleur du fond
  }
  Pave rotation() { for (Forme f : formes) f.rotation(); /*angle+=HALF_PI;*/ rot++; return this; }
  Pave symetrie() { for (Forme f : formes) f.symetrie(); /*angle=(PI-angle);*/ sym=!sym; return this; }
  
  Pave retraitGauche() { retrait=new RetraitGauche(); return this; }
  Pave retraitDroit()  { retrait=new RetraitDroit();  return this; }
  
  Pave rotation (int n) { for (int i=0; i<n; i++) rotation(); return this; }
  int largeur() { if (formes==null) return 1; return formes[formes.length-1].largeur(); }

  void manoeuvrer() {} // inversion de l'aiguille
  
  void colorer(int c) { couleur=c; } // couleur pave (derniere forme)
  
  void feu(int c) {} // feu du signal

  Point[] getPoints() { return formes[formes.length-1].points; }
}

//  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //

class PaveAiguille extends Pave {
  PaveAiguille(float a,boolean s) { super(a,s,new Arc(),new Droit()); }

  void manoeuvrer() { Forme f; f=formes[0]; formes[0]=formes[1]; formes[1]=f; } // permutation
}

//  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //

class PaveDroit extends Pave {
  PaveDroit(float a,boolean s) { super(a,s,new Droit()); }
}

//  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //

class PaveSignal extends Pave {
  PaveSignal(float a,boolean s,int c) { super(a,s,new Cible(),new Feu(c),new Droit()); }

  void feu(int c) { Feu feu=(Feu)formes[1]; feu.c=c; }
  int getFeu() { return ((Feu)formes[1]).c; }
}

//  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //

class PaveDroitN extends Pave {
  PaveDroitN(float a,boolean s,int n) { super(a,s,new DroitN(n)); }
}

//  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //

class PaveArc extends Pave {
  PaveArc(float a,boolean s) { super(a,s,new Arc()); }
}

//  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //  //

class PaveArcN extends Pave {
  PaveArcN(float a,boolean s,int n) { super(a,s,new ArcN(n)); }
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////